<?php

/********************************************************************
 * 
 * 外部からの投稿受付処理
 * 　　POST :
 * 
 ********************************************************************/
//クローラー判定
$userAgent = $_SERVER['HTTP_USER_AGENT'] ?? "";
$isCrawler = preg_match('/bot|crawl|slurp|spider/i', $userAgent);
if ($isCrawler) {
  //とりあえず成功ということにしとく
  echo '{"status":"success"}';
  exit();
}

//共通処理呼び出し
$require_login = false; //ログイン不要
$no_nsfw_check = true; //NSFWチェック不要
$no_entry_check = true;
require_once("../common.php");

//外部用APIキー管理
require_once("./external_token.php");

//認証処理として呼び出された場合の処理
$callback_url =  filter_input(INPUT_GET, 'callback');
if ($callback_url) {
  $app_title =  filter_input(INPUT_GET, 'app_title') ?? "";
  if ($app_title = "") {
    echo "パラメータが不正です";
    $db->close();
    exit;
  }
  $db->close();
  //確認画面に移行
  $url = $PATH_INFO["system_request"];
  $url = str_replace("callback=", "call=", $url);
  $url = $url .= "&msg=" . urlencode("外部アプリケーション「{$app_title}」からの書き込みを許可しますか？") . "&force=true";
  header("Location: {$redirect_rel}login.php?request=" . $url);
  $db->close();
  exit;
}

//外部認証承諾時
$call_url =  filter_input(INPUT_GET, 'call');
if ($call_url && $LOGIN) {
  //ログイン済みの場合はコールバック先にAPIキーを渡す
  $key = generateDisposableApiKey($rel);
  header("Location: $call_url?apikey=$key");
  $db->close();
  exit;
}

//認証処理として呼び出された場合の処理2 TOKEN確認
$pin =  filter_input(INPUT_GET, 'pin');
if ($pin) {
  //外部ポストのAPIキー確認
  $db->close();
  if (!isApiKeyValid($rel, $pin)) {
    header('HTTP/1.0 403 Forbidden');
    echo "Invalid PIN";
    $db->close();
    exit();
  } else {
    echo '{"status":"success", "display_name":"' . $SETTING['display_name'] . '"}';
    $db->close();
    exit();
  }
}

//外部ポストのAPIキー確認
$token = filter_input(INPUT_POST, 'apikey') ?? "";
require_once("./external_token.php");
if (!isApiKeyValid($rel, $token)) {
  $db->close();
  header('HTTP/1.0 403 Forbidden');
  echo "Invalid API key";
  $db->close();
  exit();
}


include "post_module.php";
$article = new article($db, $SETTING, $DEMO_MODE);

//並べ替えモード
$mode = filter_input(INPUT_POST, 'mode') ?? "post";
if ($mode == "sort") {
  $result = $article->Sort("");
  $id = $result['id'];
  $idx = $result['image_index'];
  $url = $PATH_INFO["url_system_root"] . "/view.php?id=$id";
  echo '{"status":"success", "id":' . $id . ', "url":"' . $url . '","image_index":' . $idx . '}';
  $db->close();
  exit;
}

//通常投稿
try {
  $result = $article->ExternalPost();

  $id = $result['id'];
  $image_idx = $result['image_index'];

  //ATOM出力
  require_once("./feed.php");
  createFeed();

  //タグクラウド生成
  require_once('./make_tagcloud.php');
  createTagcloud("{$rel}$system_db_file");
} catch (Exception $ex) {
  echo '{"status":"error","message":"' . $ex->getMessage()  . '"}';
  exit;
} finally {
  $db->close();
}

//表示用URL
$url = $PATH_INFO["url_system_root"] . "/view.php?id=$id";


//結果を出力
echo '{"status":"success", "id":' . $id . ', "url":"' . $url . '","image_index":' . $image_idx . '}';
