<?php

//APIキー発行
function generateApiKey($rel, $comment)
{
  $key = bin2hex(random_bytes(16)); // 16 bytes = 128 bits
  $issued = date('Y-m-d H:i:s');
  $file = fopen($rel . 'env/apikeys.php', 'a');
  fwrite($file, $key . ',' . $issued . ',' . $comment . "\n");
  fclose($file);
  return $key;
}

//使い捨てキーを発行
function generateDisposableApiKey($rel)
{
  $comment = "!disposable!";
  $key = bin2hex(random_bytes(16)); // 16 bytes = 128 bits
  $issued = date('Y-m-d H:i:s');
  $file = fopen($rel . 'env/apikeys.php', 'a');
  fwrite($file, $key . ',' . $issued . ',' . $comment . "\n");
  fclose($file);
  return $key;
}


//APIキー存在確認
function isApiKeyValid($rel, $apiKey)
{

  if (file_exists($rel . 'env/apikeys.php')) {
    $file = file($rel . 'env/apikeys.php');
    foreach ($file as $line) {
      $parts = explode(',', trim($line));
      if ($parts[0] == $apiKey) {
        if ($parts[2] == "!disposable!") {
          //使い捨てキーのため削除
          removeApiKey($rel, $apiKey);
        }
        return true;
      }
    }
  }
  return false;
}

//APIキー削除
function removeApiKey($rel, $apiKey)
{

  if (file_exists($rel . 'env/apikeys.php')) {
    $file = file($rel . 'env/apikeys.php');
    $newFile = fopen($rel  . 'env/apikeys.php', 'w');
    foreach ($file as $line) {
      $parts = explode(',', trim($line));
      if ($parts[0] != $apiKey && $parts[2] != "!disposable!") {
        fwrite($newFile, $line);
      }
    }
    fclose($newFile);
  }
}

//APIキー存在チェック&応答
function verifyApiKey($rel)
{
  $apiKey = $_GET['apikey'];
  if (!isApiKeyValid($rel, $apiKey)) {
    header('HTTP/1.0 403 Forbidden');
    echo "Invalid API key";
    exit();
  }
  removeApiKey($rel, ""); //使い捨てキーを削除
}

//APIキー一覧表示
function viewApiKeys($rel)
{
  removeApiKey($rel, ""); //使い捨てキーを削除

  $file = $rel . 'env/apikeys.php';
  if (file_exists($file)) {
    $file = file($file);
    $result = array();
    foreach ($file as $line) {
      $parts = explode(',', trim($line));
      $result[] = $parts;
    }
    return $result;
  } else {
    return array();
  }
}
