<?php

function createFeed()
{
    global $db;
    global $SETTING;
    global $PATH_INFO;

    include "../module/AtomFeed.php";
    include "../module/AtomEntry.php";

    try {
        createFeedSub();

        if ($SETTING['use_portal_feed']) {
            createFeedSubB();

            // POSTするデータ
            $postData = array(
                'feed_url' => $PATH_INFO['url_system_root'] . "/portal.xml"
            );
            $url_origin = $SETTING['portal_feed_urls'] ?? 'https://ppp.kannagi.net/portal/index.php';
            if ($url_origin == "") {
                $url_origin = 'https://ppp.kannagi.net/portal/index.php';
            }
            $urls = explode(',', $url_origin);
            foreach ($urls as $url) {
                // cURLを初期化して設定
                $curl = curl_init();
                curl_setopt($curl, CURLOPT_URL, $url);
                curl_setopt($curl, CURLOPT_POST, true);
                curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($postData));
                curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
                // リクエストを実行してレスポンスを取得
                $response = curl_exec($curl);
                debug_f($url, $response);
            }
            // cURLを終了
            curl_close($curl);
        }
    } catch (Exception $ex) {
        exit;
    }
}

//atom.xmlを出力
function createFeedSub()
{
    global $db;
    global $SETTING;
    global $PATH_INFO;

    try {
        $idx = 0;

        $result = $db->query("select articles.*, count(images.id) as image_count, MIN(images.thumb_name) as thumb_name From articles LEFT OUTER JOIN images on articles.id = images.article_id  Where hidden != 1  group by articles.id ORDER BY created_at DESC LIMIT 10");

        while ($row = $result->fetchArray()) {
            if ($idx == 0) {
                $atom = new AtomFeed(['xmlns:ppp' => 'https://ppp.kannagi.net/ppp-namespace', 'xml:lang' => 'ja']);
                $atom->title($SETTING['site_title']);
                $atom->link($PATH_INFO['url_system_root'], 'alternate', 'text/html', 'url');
                $atom->link($PATH_INFO['url_system_root'] . "/atom.xml", 'self');
                $atom->id($PATH_INFO['url_system_root'] . "/atom.xml");
                $atom->updated($row['created_at']); //1件目の記事の日時
                $atom->author([
                    'name' => $SETTING['display_name']
                ]);
                $atom->addCustomElement("ppp:nsfw", $SETTING["nsfw"]);
                $atom->addCustomElement("ppp:description", h($SETTING["twitter_card_text"]));
                $atom->addCustomElement("ppp:site_tags", h($SETTING["portal_tags"]));
            }

            $entry = new AtomEntry();
            $entry->title($row['title']);
            $entry->link($PATH_INFO['url_system_root'] . "/view.php?id=" . $row["id"], 'alternate', 'text/html', 'url');
            $entry->id($PATH_INFO['url_system_root'] . "/view.php?id=" . $row["id"]);
            $entry->addCustomElement("ppp:nsfw", $row["nsfw"]);
            $entry->addCustomElement("ppp:tags", h(trim($row["tags"])));
            $entry->addCustomElement("ppp:images", h($row["image_count"]));

            $summary = "";
            if ($row["comment"] && $row["comment"] != "") {
                $summary = preg_replace("/\r|\n|\r\n/", "", strip_tags($row["comment"]));
                if (mb_strlen($summary) > 100) {
                    $summary = mb_substr($summary, 0, 100, 'UTF-8') . '…';
                }
            } else {
                $summary = $row['title'];
            }
            $entry->summary($summary);

            if ($row["thumb_name"]) {
                $entry->link($PATH_INFO['url_system_root'] . "/images/" . $row["thumb_name"], 'related', 'image/jpeg', 'thumbnail');
            }


            $entry->updated($row["created_at"]);
            $entry->author([
                'name' => $SETTING['display_name']
            ]);
            $atom->addEntry($entry);

            $idx++;
        }
        $file_name = "../atom.xml";
        if ($idx > 0) {
            file_put_contents($file_name, $atom->saveXml());
        }
    } catch (Exception $ex) {
        exit;
    }
}

//ポータル送信用ATOMを生成（非送信タグの記事を含まない）
function createFeedSubB()
{
    global $db;
    global $SETTING;
    global $PATH_INFO;

    try {
        $idx = 0;

        //非送信タグ一覧
        $select_tags = explode(' ', $SETTING['portal_post_tags']);
        $tag_select = '';
        if ($SETTING['portal_post_tags']) {
            foreach ($select_tags as $tag) {
                $tag_select = $tag_select .  " or tags like '% " . h($tag) . " %'";
            }
            $tag_select = " and ( " . substr($tag_select, 4) . " )";
        }

        $exclude_portal_post_tags = explode(' ', $SETTING['exclude_portal_post_tags']);
        $tag_exclude = '';
        if ($SETTING['exclude_portal_post_tags']) {
            foreach ($exclude_portal_post_tags  as $tag) {
                $tag_exclude = $tag_exclude .  " and tags not like '% " . h($tag) . " %'";
            }
            $tag_exclude = " and ( " . substr($tag_exclude, 5) . " )";
        }
        $result = $db->query("select articles.*, count(images.id) as image_count, MIN(images.thumb_name) as thumb_name From articles LEFT OUTER JOIN images on articles.id = images.article_id  Where hidden != 1 {$tag_select} {$tag_exclude} group by articles.id ORDER BY created_at DESC LIMIT 10");

        while ($row = $result->fetchArray()) {
            if ($idx == 0) {
                $atom = new AtomFeed(['xmlns:ppp' => 'https://ppp.kannagi.net/ppp-namespace', 'xml:lang' => 'ja']);
                $atom->title($SETTING['site_title']);
                $atom->link($PATH_INFO['url_system_root'], 'alternate', 'text/html', 'url');
                $atom->link($PATH_INFO['url_system_root'] . "/portal.xml", 'self');
                $atom->id($PATH_INFO['url_system_root'] . "/portal.xml");
                $atom->updated($row['created_at']); //1件目の記事の日時
                $atom->author([
                    'name' => $SETTING['display_name']
                ]);
                $atom->addCustomElement("ppp:nsfw", $SETTING["nsfw"]);
                $atom->addCustomElement("ppp:description", h($SETTING["twitter_card_text"]));
                $atom->addCustomElement("ppp:site_tags", h($SETTING["portal_tags"]));
                if ($SETTING["use_ogimage"]) {
                    $atom->addCustomElement("ppp:ogimage", $PATH_INFO['url_system_root'] . '/images/ogimage.jpg');
                }
            }

            $entry = new AtomEntry();
            $entry->title($row['title']);
            $entry->link($PATH_INFO['url_system_root'] . "/view.php?id=" . $row["id"], 'alternate', 'text/html', 'url');
            $entry->id($PATH_INFO['url_system_root'] . "/view.php?id=" . $row["id"]);
            $entry->addCustomElement("ppp:nsfw", $row["nsfw"]);
            $entry->addCustomElement("ppp:tags", h(trim($row["tags"])));
            $entry->addCustomElement("ppp:images", h($row["image_count"]));

            $summary = "";
            if ($row["comment"] && $row["comment"] != "") {
                $summary = preg_replace("/\r|\n|\r\n/", "", strip_tags($row["comment"]));
                if (mb_strlen($summary) > 100) {
                    $summary = mb_substr($summary, 0, 100, 'UTF-8') . '…';
                }
            } else {
                $summary = $row['title'];
            }
            $entry->summary($summary);

            if ($row["thumb_name"]) {
                $entry->link($PATH_INFO['url_system_root'] . "/images/" . $row["thumb_name"], 'related', 'image/jpeg', 'thumbnail');
            }


            $entry->updated($row["created_at"]);
            $entry->author([
                'name' => $SETTING['display_name']
            ]);
            $atom->addEntry($entry);

            $idx++;
        }
        $file_name = "../portal.xml";
        if ($idx > 0) {
            file_put_contents($file_name, $atom->saveXml());
        }
    } catch (Exception $ex) {
        exit;
    }
}
function removeRequest($id)
{

    global $db;
    global $SETTING;
    global $PATH_INFO;

    include "{$PATH_INFO['system_root_rel']}/module/AtomFeed.php";
    include "{$PATH_INFO['system_root_rel']}/module/AtomEntry.php";
    $atom = new AtomFeed(['xmlns:ppp' => 'https://ppp.kannagi.net/ppp-namespace', 'xml:lang' => 'ja']);
    $atom->title($SETTING['site_title']);
    $atom->link($PATH_INFO['url_system_root'], 'alternate', 'text/html', 'url');
    $atom->link($PATH_INFO['url_system_root'] . "/remove_request.xml", 'self');
    $atom->id($PATH_INFO['url_system_root'] . "/remove_request.xml");
    $atom->author([
        'name' => $SETTING['display_name']
    ]);
    if ($id == "ALL") {
        //IDとして"ALL"が渡された場合はサイト情報自体を削除
        $atom->addCustomElement("ppp:request", 'remove_site');
    } else {
        $atom->addCustomElement("ppp:request", 'remove_feed');
    }
    $entry = new AtomEntry();
    $entry->id($PATH_INFO['url_system_root'] . "/view.php?id=" . $id);
    $atom->addEntry($entry);
    $file_name = "{$PATH_INFO['system_root_rel']}/remove_request.xml";
    file_put_contents($file_name, $atom->saveXml());

    try {
        if ($SETTING['use_portal_feed']) {
            // POSTするデータ
            $postData = array(
                'remove_request_url' => $PATH_INFO['url_system_root'] . "/remove_request.xml"
            );
            $urls = explode(',', $SETTING['portal_feed_urls']);
            if ($urls == "") {
                $urls = 'https://ppp.kannagi.net/portal/index.php';
            }
            foreach ($urls as $url) {
                // cURLを初期化して設定
                $curl = curl_init();
                curl_setopt($curl, CURLOPT_URL, $url);
                curl_setopt($curl, CURLOPT_POST, true);
                curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($postData));
                curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);

                // リクエストを実行してレスポンスを取得
                $response = curl_exec($curl);
                debug_f($url, $response);
            }
            // cURLを終了
            curl_close($curl);
        }
    } catch (Exception $ex) {
        exit;
    }
}
