<?php

/********************************************************************
 * 
 * 記事 削除処理
 * 　　GET : target 削除対象となるLogのID。必須。
 * 
 ********************************************************************/
//クローラー判定
$userAgent = $_SERVER['HTTP_USER_AGENT'];
$isCrawler = preg_match('/bot|crawl|slurp|spider/i', $userAgent);
if ($isCrawler) {
  //とりあえず成功ということにしとく
  echo '{"status":"success"}';
  exit();
}

//共通処理呼び出し
$require_login = false; //ログイン不要
$no_entry_check = true;
$no_nsfw_check = true;
require_once("../common.php");
if (!$SETTING['use_guestwrite']) {
  $db->close();
  showMessage($mode, "error", "ゲスト書き込みが無効になっています");
  exit;
}

$mode = "GET";
$target = filter_input(INPUT_GET, 'target', FILTER_SANITIZE_NUMBER_INT); //処理対象LOG ID
$delete_key = filter_input(INPUT_GET, 'delete_key');
if ($target == "") {
  $mode = "POST";
  $target = filter_input(INPUT_POST, 'target', FILTER_SANITIZE_NUMBER_INT); //処理対象LOG ID
  $delete_key = filter_input(INPUT_POST, 'delete_key');
}


if (!$target || !$delete_key) {
  $db->close();
  showMessage($mode, "error", "削除キーを入力してください");
  exit;
}

//削除キーを確認
if ($target) {
  $stmt = $db->prepare("select id,delete_key From articles where id=:id and delete_key not null and delete_key != ''");
  $stmt->bindValue(':id',  $target);
  $result = $stmt->execute();
  $row = $result->fetchArray();
  if (!$row || !password_verify($delete_key, $row['delete_key'])) {
    echo '削除キーが無効です';
    exit;
  }
}

include "post_module.php";
$article = new article($db, $SETTING, $DEMO_MODE);

try {
  $article->RemoveArticle($target);
} catch (Exception $ex) {
  showMessage($mode, "error", $ex->getMessage());
} finally {
  $db->close();
}
showMessage($mode, "success", "削除しました<br><a href='../index.php'>戻る</a>");

function showMessage($mode, $status, $msg)
{
  if ($mode == "GET") {
    echo $msg;
  } else {
    echo '{"status":"' . $status . '","message":"' . $msg . '"}';
  }
}
