<?php

/********************************************************************
 * 
 * いいね！処理
 * 　　GET : target いいね対象となるLogのID。必須。
 * 
 ********************************************************************/
//クローラー判定
$userAgent = $_SERVER['HTTP_USER_AGENT'];
$isCrawler = preg_match('/bot|crawl|slurp|spider/i', $userAgent);
if ($isCrawler) {
    //とりあえず成功ということにしとく
    echo '{"status":"success"}';
    exit();
}

//共通処理呼び出し
$require_login = false; //ログイン不要
$no_entry_check = true;
$no_nsfw_check = true;
require_once("../common.php");

$target = filter_input(INPUT_GET, 'target', FILTER_SANITIZE_NUMBER_INT); //処理対象LOG ID
if ($target == "") {
    echo '{"status":"error", "message":"対象が指定されていません"}';
    exit;
}
if (!isset($_SERVER['HTTP_REFERER'])) {
    echo '{"status":"error", "message":"不正な呼出しです"}';
    exit;
}
try {
    date_default_timezone_set('Asia/Tokyo');
    $date = date("Y-m-d H:i:s");
    $before24h = date('Y-m-d H:i:s', strtotime('-24 hours', strtotime($date)));  // 24時間前の日時を計算して取得
    $stmt = $db->prepare("select * from activity where target=:id and from_ip = :from and action = 'like' and created_at > :beforeTime Limit 1");
    $stmt->bindValue(':id',  $target);
    $stmt->bindValue(':from',  $_SERVER['REMOTE_ADDR']);
    $stmt->bindValue(':beforeTime',  $before24h);
    $result = $stmt->execute();
    $row = $result->fetchArray();
    if ($row) {
        //24時間以内に同一のイイネあり

        $like = 0;
        $stmt = $db->prepare("select like from articles where id=:id");
        $stmt->bindValue(':id',  $target);
        $result = $stmt->execute();
        $row = $result->fetchArray();
        if ($row) {
            $like = $row['like'];
        }

        $db->close();
        echo '{"status":"success", "like":"' . $like . '"}';
        exit;
    }

    $db->exec('begin Immediate');
    //記事のイイネ数を増加
    $stmt = $db->prepare("update articles set like = (like + 1) where id=:id");
    $stmt->bindValue(':id',  $target);
    $result = $stmt->execute();

    //アクティビティを記録（連打防止）
    $stmt = $db->prepare("insert into activity(created_at, from_ip, action, target) values(:created_at, :from, :action, :id)");
    $stmt->bindValue(':id',  $target);
    $stmt->bindValue(':created_at',  $date);
    $stmt->bindValue(':from',  $_SERVER['REMOTE_ADDR'] ?? "unknonw");
    $stmt->bindValue(':action',  'like');
    $result = $stmt->execute();

    //古いアクティビティを削除
    $before7d = date('Y-m-d H:i:s', strtotime('-7 days', strtotime($date)));  // 7日前の日時を計算して取得
    $stmt = $db->prepare("delete from activity where created_at < :beforeTime");
    $stmt->bindValue(':beforeTime',  $before7d);
    $result = $stmt->execute();


    $db->exec('commit');

    //記事のイイネ数を取得
    $like = 0;
    $stmt = $db->prepare("select like from articles where id=:id");
    $stmt->bindValue(':id',  $target);
    $result = $stmt->execute();
    $row = $result->fetchArray();
    if ($row) {
        $like = $row['like'];
    }
} catch (Exception $ex) {
    echo '{"status":"error", "message":"' . $ex->getMessage()  . '"}';
} finally {
    $db->close();
}

echo '{"status":"success", "like":"' . $like . '"}';
