<?php

/********************************************************************
 * 
 * タグクラウド挿入用PHP生成処理
 * 
 ********************************************************************/

function createTagcloud($systemdbfile)
{
    //DBを開く
    $db = new SQLite3("../env/$systemdbfile");

    // log テーブルからタグ一覧を取得
    $results = $db->query('SELECT tags From articles order by created_at DESC LIMIT 300');

    // タグをカウントするための連想配列
    $tagCounts = array();

    // 各レコードについて、タグをスペース区切りで分割してカウント
    while ($row = $results->fetchArray()) {
        $tag = trim($row['tags']);
        $tags = explode(' ', $tag);
        foreach ($tags as $tag) {
            if ($tag != "") {
                if (array_key_exists($tag, $tagCounts)) {
                    $tagCounts[$tag]++;
                } else {
                    $tagCounts[$tag] = 1;
                }
            }
        }
    }
    // カウント結果を降順にソート
    arsort($tagCounts);

    // タグクラウドを出力
    $tagcloud_links = '<ul class="tag-cloud">';
    $tagcloud_links_more = '<ul class="tag-cloud tag-cloud-more" style="display: none;">';
    $tagcloud_nolink_sys = '<ul class="tag-cloud">';
    $tagcloud_nolink_more_sys = '<ul class="tag-cloud tag-cloud-more" style="display: none;">';
    $tagcloud_nolink = '<ul class="tag-cloud">';
    $tagcloud_nolink_more = '<ul class="tag-cloud  tag-cloud-more" style="display: none;">';

    $tagcloud_list = "";
    $idx = 0;
    $cnt = 0;
    foreach ($tagCounts as $tag => $count) {
        $ntag = htmlspecialchars($tag);
        if (substr($ntag, 0, 1) != "-") //-から始まっているタグはタグクラウド化しない
        {
            if ($cnt < 10) {
                //表示用のタグクラウドは10件まで出力
                $tagcloud_links = $tagcloud_links . '<li class="tag"><a href="./list.php?q=' . urlencode("#" . $ntag) . '">#' . $ntag . '</a></li>';
                $tagcloud_nolink_sys = $tagcloud_nolink_sys .   '<li class="tag">#' . $ntag . '</li>';
                $tagcloud_nolink = $tagcloud_nolink . '<li class="tag">#' . $ntag . '</li>';
            } else {
                //非表示用タグクラウド
                $tagcloud_links_more = $tagcloud_links_more . '<li class="tag"><a href="./list.php?q=' . urlencode("#" . $ntag) . '">#' . $ntag . '</a></li>';
                $tagcloud_nolink_more_sys = $tagcloud_nolink_more_sys .  '<li class="tag">#' . $ntag . '</li>';
                $tagcloud_nolink_more = $tagcloud_nolink_more . '<li class="tag">#' . $ntag . '</li>';
            }
            $tagcloud_list = $tagcloud_list . "'" . $ntag . "',";
            $cnt++;
        } else {
            // システム用タグクラウドには-タグも記録する
            if ($cnt < 10) {
                //表示用のタグクラウドは10件まで出力
                $tagcloud_nolink_sys = $tagcloud_nolink_sys .  '<li class="tag">#' . $ntag . '</li>';
            } else {
                //非表示用タグクラウド
                $tagcloud_nolink_more_sys = $tagcloud_nolink_more_sys .  '<li class="tag">#' . $ntag . '</li>';
            }
        }
        $idx++;
    }
    $more_link = "";
    if ($idx > 10) {
        $more_link = '<li class="tag-cloud-more-link" style="cursor:pointer;"> ▼</li>';
    }
    $tagcloud_links = $tagcloud_links . $more_link .  '</ul>';
    $tagcloud_links_more = $tagcloud_links_more .  '</ul>';
    $tagcloud_nolink_sys = $tagcloud_nolink_sys . $more_link .  '</ul>';
    $tagcloud_nolink_more_sys = $tagcloud_nolink_more_sys .  '</ul>';
    $tagcloud_nolink = $tagcloud_nolink . $more_link .  '</ul>';
    $tagcloud_nolink_more = $tagcloud_nolink_more .  '</ul>';
    $tagcloud_list = $tagcloud_list . ']';

    $fp = fopen("../env/tagcloud.php", "w");
    fwrite($fp, "<?php\n");
    fwrite($fp, '$tagcloud_links = "' . preg_replace('/[\'"$]/', '\\\\$0', $tagcloud_links)  . '";' . "\n");
    fwrite($fp, '$tagcloud_links_more = "' . preg_replace('/[\'"$]/', '\\\\$0', $tagcloud_links_more)  . '";' . "\n");
    fwrite($fp, '$tagcloud_nolink_sys = "' . preg_replace('/[\'"$]/', '\\\\$0', $tagcloud_nolink_sys)  . '";' . "\n");
    fwrite($fp, '$tagcloud_nolink_more_sys = "' . preg_replace('/[\'"$]/', '\\\\$0', $tagcloud_nolink_more_sys)  . '";' . "\n");
    fwrite($fp, '$tagcloud_nolink = "' . preg_replace('/[\'"$]/', '\\\\$0', $tagcloud_nolink)  . '";' . "\n");
    fwrite($fp, '$tagcloud_nolink_more = "' . preg_replace('/[\'"$]/', '\\\\$0', $tagcloud_nolink_more)  . '";' . "\n");
    fwrite($fp, '$tagcloud_list = "' . preg_replace('/[\'"$]/', '\\\\$0', $tagcloud_list)  . '";');
    fclose($fp);

    // データベース接続を閉じる
    $db->close();
}
