<?php

//共通処理呼び出し
$require_login = true; //ログイン必要
$no_entry_check = true;
$no_nsfw_check = true;
require_once("../common.php");

//入力値のフィルタリング
$body = filter_input(INPUT_POST, 'body');
$id = filter_input(INPUT_POST, 'id');
$max_images = filter_input(INPUT_POST, 'max_images') ?? 4;
if (!$body || !$id) {
    //必須項目なし
    echo ('{"status":"error","message":"必須項目が指定されていません"}');
    exit;
}

//logsテーブルから記事を検索
try {
    $stmt = $db->prepare('SELECT * From articles Where id= :id');
    $stmt->bindValue(':id',  $id);
    $result = $stmt->execute();
    if (!$row = $result->fetchArray()) {
        //指定されたログが存在しない
        echo ('{"status":"error","message":"指定されたログが存在しません ' . $id .  '"}');
        $db->close();
        exit;
    }
} catch (Exception $ex) {
    $db->close();
    echo 'システムエラーが発生しました<br>';
    $error = $ex->getTraceAsString();
    exit;
}
//NSFW確認
$nsfw = $row['nsfw'] ?? false;

//画像一覧を取得
try {
    $stmt = $db->prepare('SELECT * FROM images Where article_id= :id Order by sort ASC LIMIT 4');
    $stmt->bindValue(':id',  $id);
    $result = $stmt->execute();
    $images = array();
    while ($row = $result->fetchArray()) {
        $images[$idx] = $row;
        $idx++;
    }
} catch (Exception $ex) {
    $db->close();
    echo 'システムエラーが発生しました<br>';
    $error = $ex->getTraceAsString();
    exit;
}
$db->close();

// POST先のURLとトークン
$post_url = $SETTING['tweet_service'];
$post_key = $SETTING['tweet_service_key'];

// POSTデータを準備
$postData = [
    'body' => $body,
    'token' => $post_key,
];

foreach ($images as $index => $image) {
    $postData['image[' . $index . ']'] = new CURLFile('../images/' . $image['thumb_l_name']);
    if (!file_exists('../images/' . $image['thumb_l_name'])) {
        echo ('{"status":"error","message":"指定されたログが存在しません ' . '../images/' . $image['thumb_l_name'] .  '"}');
        exit;
    }
    if ($index == $max_images) {
        break;
    }
}
if ($nsfw) {
    $postData['nsfw'] = true;
}


try {
    // cURLセッションを初期化
    $ch = curl_init();

    // cURLオプションを設定

    curl_setopt($ch, CURLOPT_USERAGENT, "PPP tweet sender");
    curl_setopt($ch, CURLOPT_REFERER, $PATH_INFO["url_system_root"] . "/api/tweet.php");

    curl_setopt($ch, CURLOPT_URL, $post_url . "/post.php");
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);

    // POSTを実行
    $response = curl_exec($ch);
    if ($response == "") {
        echo '{"status":"error", "message":"何らかのエラーが発生しました ' .  curl_error($ch) . "  " . $post_url . "/post.php" . '"}';
    }
    echo $response;
} catch (Exception $ex) {
    echo '{"status":"error", "message":"' . $ex->getMessage() . '"}';
} finally {
    // cURLセッションを終了
    curl_close($ch);
}
