<?php

//共通処理呼び出し
$require_login = true; //ログイン必須
$no_entry_check = true;
$no_nsfw_check = true;
require_once("../common.php");
$db->close();
if (!$VERSION) {
    $VERSION = "0.0.0";
}
// バージョン取得用URL
$url = 'https://ppp.kannagi.net/download/';

// commandの値を取得
$command = $_GET['command'] ?? '';


// バージョン取得用URLからバージョン番号を取得する
$remote_version_data = file_get_contents($url . "version.json");
if ($remote_version_data === false) {
    echo ('{"status":"error", "message":"バージョン情報の取得に失敗しました。"}');
    exit;
}
$remote_version = json_decode($remote_version_data)->Version;
if (json_last_error() !== JSON_ERROR_NONE) {
    echo ('{"status":"error", "message":"バージョン情報が不正です。"}');
    exit;
}

// バージョンを比較して、新しいバージョンがある場合はアップデートが必要とするメッセージを表示する
if ($command === '') {
    if (version_compare($remote_version, $VERSION, '>')) {
        echo ('{"status":"success", "message":"新しいバージョンがあります", "new-version":"' . $remote_version . '"}');
        exit;
    } else {
        echo ('{"status":"success", "message":"最新のバージョンを使用しています", "new-version":""}');
        exit;
    }
}

// コマンドがupdateの場合、アップデートを実行する
if ($command === 'update' || $command === 'initialize') {
    // zipファイルをダウンロードして解凍する
    $zip_file = json_decode($remote_version_data)->ZipFileName;
    $zip_url = $url . $zip_file;
    $zip_data = file_get_contents($zip_url);
    if ($zip_data === false) {
        echo ('ZIPファイルのダウンロードに失敗しました。');
        exit;
    }
    $temp_file = tempnam(sys_get_temp_dir(), 'zip');
    if ($temp_file === false) {
        echo ('一時ファイルの作成に失敗しました。');
        exit;
    }
    if (file_put_contents($temp_file, $zip_data) === false) {
        echo ('一時ファイルにZIPデータを書き込めません。');
        exit;
    }
    $zip = new ZipArchive;
    if ($zip->open($temp_file) !== true) {
        echo ('ZIPファイルの解凍に失敗しました。');
        exit;
    }
    if ($zip->extractTo(dirname(__FILE__, 2)) !== true) {
        echo ('ZIPファイルの解凍に失敗しました。');
        exit;
    }
    $zip->close();

    //DB更新へ移行
    if ($command === 'update') {
        header("Location: ../update.php");
    } else {
        //初回起動時自動アップデートの場合はリダイレクト指定付きでupdate.phpに移動する
        header("Status: 301 Moved Permanently");
        header("Location: ../update.php?mode=redirect");
    }
    exit;
}
