<?php

/*************************************************
 * 
 * 入場確認画面
 * 
 *************************************************/


$require_login = false; //ログイン不要
$no_entry_check = true; //common内でのNSFW Checkを無効化
require_once("./common.php");
$db->close();

//入力値の受け取り
$ENTRY_CONSENT =  filter_input(INPUT_POST, 'entry') ?? "";
$entry_password = filter_input(INPUT_POST, 'password') ?? "";
$entry_title =  filter_input(INPUT_GET, 'title') ?? filter_input(INPUT_POST, 'title') ?? "";
$request =  filter_input(INPUT_GET, 'request') ??  filter_input(INPUT_POST, 'request') ?? "";
$request_url = filter_input(INPUT_GET, 'request_url') ?? filter_input(INPUT_POST, 'request_url') ?? "";
$location = "";
$err_mode = false;


if ($ENTRY_CONSENT == "true") {
    $password_check = true;
    if ($SETTING['entry_password']) {
        $check_pass = $SETTING['entry_password'];
        if (!password_verify($check_pass, password_hash($entry_password, PASSWORD_DEFAULT))) {
            //送信された「あいことば」が間違えている
            $err_mode = true;
            $password_check = false;
        }
    }
    if ($password_check) {
        //NSFW許可をCookieに登録
        $cookie_expires = time() + 30 * 24 * 3600;
        setcookie('entry_consent', '1', $cookie_expires);
        if ($entry_password) {
            setcookie('entry_password', password_hash($entry_password, PASSWORD_DEFAULT), $cookie_expires);
        }
        if ($request != "") {
            //記事番号が指定されている場合はその記事に飛ぶ
            if ($SETTING['use_rewrite']) {
                if ($request_url != "") {
                    header("Location: ./" . $request_url . "?back_url=" . $BACK_URL);
                } else {
                    header("Location: ./log/" . $request . "?back_url=" . $BACK_URL);
                }
            } else {
                header("Location: ./view.php?id=" . $request . "&back_url=" . $BACK_URL);
            }
            exit;
        }
        header("Location: index.php");
        exit;
    }
} else if ($ENTRY_CONSENT == "false") {
    setcookie('entry_consent', '0', $cookie_expires);
    header("Location: https://www.google.com");
    exit;
}
//Cookie確認
$ENTRY_CONSENT = filter_input(INPUT_COOKIE, 'entry_consent') ?? 0;
if ($ENTRY_CONSENT == 1) {
    //同意済み

    //EntryPasswordの正当性をチェック
    if ($SETTING['entry_password']) {
        $cookie_password = filter_input(INPUT_COOKIE,  'entry_password') ?? "";
        $check_pass = $SETTING['entry_password'];
        if (password_verify($cookie_password, $check_pass)) {
            header("Location: index.php");
            exit;
        }
    } else {
        header("Location: index.php");
        exit;
    }
}

$mode = "site";
$caption = "サイト";
$cancel = "退出します";
$cancel_url = './entry.php?entry=false';
$location = "";
$title = $SETTING['site_title'];
if ($entry_title) {
    //記事タイトルが指定されている場合は個別記事Entry
    $mode = "article";
    $caption = "記事";
    $cancel = "いいえ、戻ります";
    $title = $nsfw_title;
    $cancel_url = './index.php';
}
if ($request != "") {
    $location = "&request=$request";
}

$instruction_text = $SETTING['entry_text'];
$instruction_text = preg_replace('/{(\d+)\-(\d+)}/i', "<img class='instraction-image' src='./images/thumb_l_image_$1_$2.jpg'>", $instruction_text);
$instruction_text = preg_replace('/{(\d+)\-(\d+) s}/i', "<img class='instraction-image' src='./images/thumb_image_$1_$2.jpg'>", $instruction_text);


//UIレンダリング
require_once('./module/NoSixTemplate.php');
if (file_exists('./env/templates/template_entry.php')) {
    $template = new NoSixTemplate('template_entry.php', './env/templates');
} else {
    $template = new NoSixTemplate('template_entry.php',     './templates');
}
$template->set_data('VERSION', $VERSION);
$template->set_data('setting', $SETTING); //Array
$template->set_Data('mode', $mode);

$template->set_Data('caption', $caption);
$template->set_Data('cancel', $cancel);
$template->set_Data('cancel_url', $cancel_url);
$template->set_Data('location', $location);
$template->set_Data('title', $title);
$template->set_Data('use_password', $SETTING['entry_password'] == true);
$template->set_Data('entry_text', $instruction_text);
$template->set_Data('error_mode', $err_mode);


$template->display();

exit;
