<?php
//共通処理呼び出し
$require_login = true; //ログイン必要
require_once("./common.php");
$db->close(); //本ページではDBを使用しない
require_once("./api/external_token.php");

//入力値の受け取り
$delete_target = filter_input(INPUT_GET, 'delete') ?? "";
$add_new_service1 = filter_input(INPUT_POST, 'service') ?? "";
$add_new_service2 = filter_input(INPUT_GET, 'service') ?? "";
$add_new_service = $add_new_service1 . $add_new_service2;
$msg = "";
if (!$delete_target == "") {
    removeApiKey($rel, $delete_target);
    $msg = "削除しました";
}
if (!$add_new_service == "") {
    $new_key = generateApiKey($rel, $add_new_service);
    $msg = "新しいAPIキー：" . $new_key;
}

$body = viewApiKeys($rel);
?>

<!doctype html>
<html lang="ja">

<head>
    <meta charset="utf-8">
    <title>外部連携管理</title>
    <meta name="description" content="">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="theme-color" content="#fafafa">
    <link rel="stylesheet" href="./style/recss.css">
    <link rel="stylesheet" href="./style/base.css">
    <link rel="icon" href="./resource/icon.png">
    <meta http-equiv="Pragma" content="no-cache">
    <meta http-equiv="Cache-Control" content="no-cache">
    <link rel="stylesheet" href="./style/system.css">
    <style>
        #control {
            margin-bottom: 2em;
            display: flex;
            width: 100%;
            flex-direction: row;
            flex-wrap: wrap
        }

        .button {
            width: 40%;
            margin: 1em auto 1em auto;
        }

        .tool {
            margin-bottom: 3em;

        }

        #update-warn {
            font-size: 0.8em;
            color: red;
        }

        .msg {
            display: block;
            padding: 1em;
            font-size: 1.5em;
            background-color: #ccc;
            margin: 1em;
        }
    </style>
    <link rel="stylesheet" href="./module/fontawesome/css/all.min.css" rel="preload">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.7.1/jquery.min.js"></script>
    <script src="./script/dialog.js?ver=<?= $VERSION ?>"></script>
    <link rel="stylesheet" href="./style/dialog.css">
    <script>
        $(document).ready(async function() {
            $('#form').submit(async function(event) {
                var service = $('input[name="service"]').val();
                if (!service) {
                    event.preventDefault();
                    await $('body').showDialog('サービス名を入力してください。');

                } else if (service.length > 30) {
                    event.preventDefault();
                    await $('body').showDialog('サービス名は30文字以内で入力してください。');

                } else if (service.indexOf(',') !== -1) {
                    event.preventDefault();
                    await $('body').showDialog('サービス名にカンマは含めないでください。');

                }
            });
        });
    </script>
</head>

<body>
    <div id="header">
        <a id="back-link" href="./setting.php" class="header-link-exit">&lt; 戻る</a>
        <div id="header-option-link-area">
            <a id="logout-link" href="./logout.php">ログアウト</a>
        </div>
    </div>
    <div id="base">
        <div id="control">
            <div id="contents-area">
                <div style="margin:1em;">
                    外部アプリケーション連携用のキーを発行・管理します。<br>
                    発行されたキーは連動するアプリケーション以外には漏らさないようにしてください。<br>
                </div>
                <div style="margin:1em;">
                    外部アプリケーションで指定するURL : <?= $PATH_INFO["url_system_root"] ?><br>
                    外部アプリケーションで指定するユーザー名： <?= $SETTING["display_name"] ?><br>
                </div>
                <?php if ($msg != "") { ?>
                    <span class="msg">
                        <?= $msg ?>
                    </span>
                <?php } ?>
                <h3>新規APIキー発行</h3>
                <div style="margin-bottom:3em">
                    <form action="./external_token_console.php" method="POST" id="form">
                        サービス名：<input type="text" name="service" class="flat-input long_input">
                        <input type="submit" value="発行" class="button" style="min-width:4em;width:4em; font-size:1em;">
                    </form>
                </div>
                <h3>発行済みAPIキー 一覧</h3>
                <table>
                    <tr>
                        <th>サービス</th>
                        <th>KEY</th>
                        <th>作成日</th>
                        <th>操作</th>
                    </tr>
                    <?php foreach ($body as $line) { ?>
                        <tr>
                            <td><?= $line[2] ?></td>
                            <td><?= $line[1] ?></td>
                            <td><?= $line[0] ?></td>
                            <td><a href="./external_token_console.php?delete=<?= $line[0] ?>">[削除]</a></td>
                        </tr>
                    <?php } ?>
                </table>
            </div>
        </div>
    </div>



</body>

</html>