<?php

//Parsedownの出力するタグにclass="md"を付与する
class ParsedownEx extends Parsedown
{
    protected function elements(array $Elements)
    {
        $markup = '';

        $autoBreak = true;

        foreach ($Elements as $Element) {
            if (empty($Element)) {
                continue;
            }

            if (isset($Element['attributes'])) {
                if (isset($Element['attributes']['class'])) {
                    $Element['attributes']['class'] = $Element['attributes']['class'] . " md";
                } else {
                    $Element['attributes']['class'] = "md";
                }
            } else {
                $Element['attributes'] = array("class" => "md");
            }

            $autoBreakNext = (isset($Element['autobreak'])
                ? $Element['autobreak'] : isset($Element['name'])
            );
            // (autobreak === false) covers both sides of an element
            $autoBreak = !$autoBreak ? $autoBreak : $autoBreakNext;

            $markup .= ($autoBreak ? "\n" : '') . $this->element($Element);
            $autoBreak = $autoBreakNext;
        }

        $markup .= $autoBreak ? "\n" : '';

        return $markup;
    }
}
