<?php

/*************************************************
 * 
 * NSFW確認画面
 * 
 *************************************************/


$require_login = false; //ログイン不要
$no_nsfw_check = true; //common内でのNSFW Checkを無効化
require_once("./common.php");

//入力値の受け取り
$NSFW_CONSENT =  filter_input(INPUT_GET, 'nsfw') ?? "";
$nsfw_title =  filter_input(INPUT_GET, 'title'); //記事タイトル
$request =  filter_input(INPUT_GET, 'request') ?? "";
$request_url = filter_input(INPUT_GET, 'request_url') ?? "";
$target_id = filter_input(INPUT_GET, "request_id") ?? "";
$location = "";


if ($NSFW_CONSENT == "true") {
    //NSFW許可をCookieに登録
    $cookie_expires = time() + 30 * 24 * 3600;
    setcookie('nsfw_consent', '1', $cookie_expires);

    if ($request != "" || $request_url != "") {
        //記事番号が指定されている場合はその記事に飛ぶ
        if ($SETTING['use_rewrite']) {
            if ($request_url != "") {
                header("Location: ./" . $request_url . "?back_url=" . $BACK_URL);
            } else {
                header("Location: ./log/" . $request . "?back_url=" . $BACK_URL);
            }
        } else {
            header("Location: ./view.php?id=" . $request . "&back_url=" . $BACK_URL);
        }
        exit;
    }
    header("Location: index.php");
    exit;
} else if ($NSFW_CONSENT == "false") {
    setcookie('nsfw_consent', '0', $cookie_expires);
    header("Location: https://www.google.com");
    exit;
}
//Cookie確認
$NSFW_CONSENT = filter_input(INPUT_COOKIE, 'nsfw_consent') ?? 0;
if ($NSFW_CONSENT == 1) {
    //同意済み
    header("Location: index.php");
    exit;
}

$title = $SETTING['site_title'];
$mode = "site";
$cancel_url = './nsfw.php?nsfw=false';
$location = "";

if ($target_id) {
    if ($target_id != "") {
        $stmt = $db->prepare('SELECT * From articles Where id= :id');
        $stmt->bindValue(':id',  $target_id);
    } else {
        $stmt = $db->prepare('SELECT * FROM articles where alt_url = :alt_url');
        $stmt->bindValue(":alt_url",  $target_url);
    }
    $result = $stmt->execute();
    if ($row = $result->fetchArray()) {
        if ($nsfw_title == "") {
            $nsfw_title = $row["title"];
        }
        if ($request_url == "") {
            $request_url = $row["alt_url"];
        }
        if ($request == "") {
            $request = $row["id"];
        }
        //Twitterカード用データの構築
        $document['card_title'] = $row['title'] . " - " . $SETTING['site_title'];

        //キャプションを取り出し
        $comment = h($row["comment"]);
        $caption = "";
        $comment = preg_replace('/{\/caption}\r\n/i', '{/caption}', $comment);
        $comment = preg_replace('/{\/caption}\n/i', '{/caption}', $comment);
        preg_match('/{caption}(.*?){\/caption}/si', $comment, $match);
        if ($match) {
            $caption = $match[1];
            $caption = convertLineBreaks($caption);
            $comment = preg_replace('/{caption}(.*?){\/caption}\r?\n?/si', '', $comment);
        }
        if ($caption == "") {
            $card_comment = preg_replace("/<script>.*<\/script>/si", "", $comment);
            $card_comment = preg_replace("/<style>.*<\/style>/si", "", $card_comment);
            $card_comment = preg_replace("/\r|\n|\r\n/", "", strip_tags($card_comment));
            if (mb_strlen($card_comment) > 100) {
                $card_comment = mb_substr($card_comment, 0, 100, 'UTF-8') . '…';
            }
        } else {
            $card_comment = preg_replace("/\r|\n|\r\n/", "", strip_tags($caption));
        }
        $document['card_comment'] = $card_comment;
        $document['card_type'] = "summary";
        $document['card_thumbnail'] = "";
        //NSFWコンテンツの場合　または画像表示しないオプションの場合はogimage
        $article['nsfw'] = true;
        if ($SETTING['use_ogimage']) {
            $document['card_type'] = "summary_large_image";
            $document['card_thumbnail'] = $PATH_INFO["url_system_root"] . '/images/ogimage.jpg';
        }
    }
}
if ($nsfw_title) {
    //記事タイトルが指定されている場合は個別記事NSFW
    $title = $nsfw_title;
    $mode = "article";
    $cancel_url = './index.php';
}
if ($request != "") {
    $location = "&request=$request";
} else if ($request_url != "") {
    $location = "&request_url=$request_url";
}

//UIレンダリング
require_once('./module/NoSixTemplate.php');
if (file_exists('./env/templates/template_nsfw.php')) {
    $template = new NoSixTemplate('template_nsfw.php', './env/templates');
} else {
    $template = new NoSixTemplate('template_nsfw.php',     './templates');
}
$template->set_data('document', $document);
$template->set_data('VERSION', $VERSION);
$template->set_data('setting', $SETTING); //Array
$template->set_Data('mode', $mode);

$template->set_Data('cancel_url', $cancel_url);
$template->set_Data('location', $location);
$template->set_Data('title', $title);


$template->display();

exit;
