<?php

$require_login = true; //ログイン必要
$no_entry_check = true; //common内でのNSFW Checkを無効化
$no_nsfw_check = true;
require_once("./common.php");

$tableName = filter_input(INPUT_POST, "table") ?? filter_input(INPUT_GET, "table") ?? "templates";
$mode = filter_input(INPUT_POST, "command") ?? "";
$body = "";
$showList = true;
$return = "./setting.php";
if ($mode == "add") {
    $body = "追加しました<br>";
    //追加モード
    $columns = $db->query("PRAGMA table_info($tableName)");
    $columnNames = [];
    $columnValues = [];

    while ($column = $columns->fetchArray(SQLITE3_ASSOC)) {
        $columnName = $column['name'];
        if ($columnName != "id" && isset($_POST[$columnName])) {
            $columnNames[] = $columnName;
            $columnValues[] = "'" . SQLite3::escapeString($_POST[$columnName]) . "'";
        }
    }
    $columnsStr = implode(", ", $columnNames);
    $valuesStr = implode(", ", $columnValues);
    $query = "INSERT INTO $tableName ($columnsStr) VALUES ($valuesStr)";
    $db->exec($query);
} else if ($mode == "update" && isset($_POST['id'])) {
    //編集モード
    $columns = $db->query("PRAGMA table_info($tableName)");
    $set = "";
    $id = SQLite3::escapeString($_POST['id']);
    while ($column = $columns->fetchArray(SQLITE3_ASSOC)) {
        $columnName = $column['name'];
        if ($columnName != "id" && isset($_POST[$columnName])) {
            $value = "'" . SQLite3::escapeString($_POST[$columnName]) . "'";
            $set .= ", $columnName = $value";
        }
    }
    $set = substr($set, 1);
    $query = "Update $tableName set $set where id = $id";
    $db->exec($query);
} else if ($mode == "delete" && isset($_POST['id'])) {
    //削除モード
    $id = SQLite3::escapeString($_POST['id']);
    $query = "delete from $tableName where id = $id";
    $db->exec($query);
} else if ($mode == "edit" && isset($_POST['id'])) {
    //編集モード
    $body = "<h1>編集</h1>";
    $id = SQLite3::escapeString($_POST['id']);
    $result = $db->query("SELECT * FROM $tableName where id = $id");
    while ($columns = $result->fetchArray(SQLITE3_ASSOC)) {
        foreach ($columns as $column => $value) {
            if ($column == "id") {
                $body .= "<input type='hidden' name='$column' id='col_$column' value='$value'><br>";
            } else {
                $value = h($value);
                $body .= "$column:<textarea type='text' class='flat-input' name='$column' id='col_$column' nowrp style='height:3em'>$value</textarea><br>";
            }
        }
    }
    $body .= "<div style='float:left'><button  class='button button_warn deletebutton' style='margin-top:0.5em'>削除</button></div>";
    $body .= "<div style='text-align:right'><button onClick=\"call_editSave()\" class='button' style='margin-top:0.5em'>保存</button> ";
    $body .= "<button onClick=\"call_cancel()\" class='button  button_normal' style='margin-top:0.5em'>キャンセル</button></div>";

    $showList = false;
    $return = "./template_console.php";
} else if ($mode == "addNew") {
    //新規モード
    $body = "<h1>追加</h1>";
    $result = $db->query("PRAGMA table_info($tableName)");
    while ($columns = $result->fetchArray(SQLITE3_ASSOC)) {
        $column = $columns["name"];
        if ($column != "id") {
            $body .= "$column:<textarea type='text'  class='flat-input' name='$column' id='col_$column' nowrp style='height:3em'></textarea><br>";
        }
    }
    $body .= "<div style='text-align:right'><button onClick=\"call_addSave()\" class='button'>追加</button> ";
    $body .= "<button onClick=\"call_cancel()\" class='button button_normal'>キャンセル</button></div>";
    $showList = false;
    $return = "./template_console.php";
}

if ($showList) {
    //一覧表示
    $columns = $db->query("PRAGMA table_info($tableName)");
    $body .= "<h2>$tableName</h2>";
    $body .= "<h3>データ</h3>";
    $result = $db->query("SELECT * FROM $tableName");
    $body .= "<div class='row-list'><table border='1' class='row-list-table'>";
    while ($column = $result->fetchArray(SQLITE3_ASSOC)) {
        $body .= "<tr><td><button onClick=\"call_edit('{$column['id']}')\">[編集]</button></td>";
        foreach ($column as $value) {
            if (mb_strlen($value ?? "") > 20) {
                $value = mb_substr($value ?? "", 0, 20, 'UTF-8') . '…';
            }
            $value = h($value);
            $body .= "<td>$value</td>";
        }
        $body .= "</tr>";
    }
    $body .= "</table></div>";
    $body .= "<div style='text-align:right'><button onClick=\"call_addNew()\" class='button' style='margin-top:0.5em'>追加</button></div>";
    $body .= '<input name="id" id="id" type="hidden">';
}


//キャッシュ無効
header('Cache-Control: no-store, no-cache, must-revalidate');
header('Cache-Control: post-check=0, pre-check=0', FALSE);
header('Pragma:no-cache');
?>
<!doctype html>
<html lang="ja">

<head>
    <meta charset="utf-8">
    <title>データ管理コンソール</title>
    <meta name="description" content="">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="theme-color" content="#fafafa">
    <link rel="stylesheet" href="./style/recss.css">
    <link rel="stylesheet" href="./style/base.css">
    <link rel="icon" href="./resource/icon.png">
    <meta http-equiv="Pragma" content="no-cache">
    <meta http-equiv="Cache-Control" content="no-cache">
    <link rel="stylesheet" href="./style/system.css">
    <link rel="stylesheet" href="./module/fontawesome/css/all.min.css" rel="preload">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.7.1/jquery.min.js"></script>
    <script src="./script/dialog.js?ver=<?= $VERSION ?>"></script>
    <link rel="stylesheet" href="./style/dialog.css">
    <script src="./script/console.js?ver=<?= $VERSION ?>"></script>
    <style>
        input {
            border: 1px solid #999
        }

        #control {
            margin-bottom: 2em;
            width: 100%;
            flex-direction: column;
            display: flex;
        }

        .row-list {
            max-width: 100%;
            overflow-x: scroll;
        }

        table {
            width: 100%;
            border-collapse: collapse;
        }

        /* テーブルの行のスタイル */
        tr {
            border-bottom: 1px solid #ddd;
            /* ボーダー線（任意） */
        }

        /* 奇数行の背景色 */
        tr:nth-child(odd) {
            background-color: #f2f2f2;
            /* 背景色 */
        }

        /* 偶数行の背景色 */
        tr:nth-child(even) {
            background-color: #ffffff;
            /* 背景色 */
        }

        /* セルのスタイル（任意） */
        td,
        th {
            padding: 8px;
            text-align: left;
            white-space: nowrap;
        }
    </style>
    <script>
        function call_edit(id) {
            $('#command').val("edit");
            $('#id').val(id);
        }

        async function call_delete(id) {
            var body = "このデータを削除してよろしいですか？";
            let result = await $("body").showDialog(body, "OK", "キャンセル");
            if (result == "Cancel") {
                return;
            }

            $('#command').val("delete");
            $('#id').val(id);
            $('form').submit();
        }

        function call_addNew() {
            $('#command').val("addNew");
        }

        function call_addSave() {
            $('#command').val("add");
        }

        function call_editSave() {
            $('#command').val("update");
        }

        $(function() {
            $(".deletebutton").on("click", async function(e) {
                e.preventDefault();
                await call_delete();
            });
        });
    </script>
</head>

<body>
    <div id="header">
        <a id="back-link" href="<?= $return ?>" class="header-link-exit">
            &lt; 戻る
        </a>
        <div id="header-option-link-area">
            <a id="logout-link" href="./logout.php">ログアウト</a>
        </div>
    </div>
    <div id="base">
        <div id="contents-area">
            <div style="margin:0 10vw">
                <form action='./template_console.php' method='POST'>
                    <?= $body ?>
                    <input name="command" id="command" type="hidden">
                </form>
            </div>
        </div>
    </div>
</body>

</html>