<?php

/**************************************************************************************
 * 
 *  Indexページ用テンプレート
 * 
 **************************************************************************************/

$hide = "";
if (!$setting["use_icon"]) {
    $hide = "hide";
}

//Consoleへのリンク部分
$post_link = "<i class='fa-regular fa-pen-to-square'></i>";
?>

<!doctype html>
<html lang="ja">

<head>
    <meta charset="utf-8">
    <title>%{$setting['site_title']} - %{$articles['title']}</title>
    <meta name="description" content="%{$document['card_comment']}">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="theme-color" content="%{$setting['image_color']}">
    <?php if ($setting['use_favicon']) { ?>
        <link rel="icon" href="./images/userfavicon.png">
    <?php } ?>
    <link rel="stylesheet" href="./style/recss.css">
    <link rel="stylesheet" href="./style/base.css?ver=<?= $VERSION ?>">
    <link rel="stylesheet" href="./style/index.css?ver=<?= $VERSION ?>">
    <link rel="stylesheet" href="./module/fontawesome/css/all.min.css" rel="preload">
    <link rel="stylesheet" href="./style/view.css?ver=<?= $VERSION ?>">
    <link rel="stylesheet" href="./env/user.css?%{$setting['css_update']}">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.7.1/jquery.min.js"></script>
    <script src="./script/common.js?ver=<?= $VERSION ?>"></script>
    <script src="./script/dialog.js?ver=<?= $VERSION ?>"></script>
    <script>
        //非同期カウンター
        async function counter(id) {
            return new Promise((resolve, reject) => {
                $.ajax({
                    type: "GET",
                    url: "./api/counter.php",
                    data: {
                        "target": id
                    },
                    success: function(response) {
                        console.log("Success: " + response);
                        var result = JSON.parse(response);
                        resolve(result)
                    },
                    error: function() {
                        reject();
                    }
                });
            });
        }

        $(async function() {
            <?php if (!$setting["use_icon"]) { ?>
                $('#profile__image').css('display', 'none');
                $('#profile__contents').css('left', "0.5em");
                $('#profile__contents').css('margin-top', "0.5em");
            <?php } ?>
            <?php if (!$setting["use_banner"]) { ?>
                $('#profile__banner').css('background-color', '%{$setting["image_color"]}');
            <?php } ?>
            $(".tag-cloud-more-link").on("click", function(e) {
                $(".tag-cloud-more").toggle(300);
            });

            var menuWidth = $(".home_menu").width();
            var itemsWidth = 0;
            $(".home_menu_item").each(function() {
                itemsWidth += $(this).outerWidth(true);
            });
            if (itemsWidth > menuWidth) {
                $(".home_menu").css("justify-content", "flex-start");
            }
            <?php if ($setting['use_feedback']) { ?>
                await counter(<?= $articles['id'] ?>);

                $("#like-it").on("click", async function() {
                    $("#like-heart").addClass("fa-solid");
                    $("#like-heart").removeClass("fa-regular");
                    $("#like-it").css("color", "#cc0000");
                    await likeIt($(this).data("target"));
                });
            <?php } ?>

        });
    </script>
</head>

<body>
    <?php if ($login) { ?>
        <div id="console-header">
            <div id="header-link-area">
                <a href="./console.php"><i class="fa-regular fa-rectangle-list"></i><span class="sp-hide"> 管理</span></a>
                <?php if ($setting['use_feedback']) { ?>
                    <span class='nowarp'><span class='like-it'><i class='fa-regular fa-eye'></i> %{$articles['views']}</span></span>&nbsp;
                    <span class='nowarp'><span class='like-it'><i id='like_heart' class='fa-regular fa-heart'></i> %{$articles['like']}</span></span>&nbsp;
                <?php } ?>
                <a href="./edit.php?id=%{$articles['id']}"><i class="fa-regular fa-pen-to-square"></i></a>
            </div>
            <div id="header-option-link-area">
                <a href="./edit.php">+<span class="sp-hide">新規</span>投稿</a>
                <span id="notification-link" style="cursor:pointer"><i id="notification" class="fa-regular fa-bell font-size:1em"></i></span>
                <a id="setting-link" href="./setting.php"><i class="fa-solid fa-gear font-size:1em"></i><span class="sp-hide">設定</span></a>
                <a id="logout-link" href="./logout.php">ログアウト</a>
            </div>
        </div>
        <script src="./script/console.js?ver=<?= $VERSION ?>"></script>

        <link rel="stylesheet" href="./style/dialog.css">
    <?php } ?>
    <div id="index-base">
        <div id="profile-area">
            <div id="profile__banner">
                <?php if ($setting['use_banner']) {
                    echo ('<img src="./images/banner.jpg" alt="タイトルバナー">');
                } else {
                    echo '<h1 id="title">' . $setting['site_title'] . '</h1>';
                }
                ?>
            </div>
            <div id="profile__image" class="%{$hide}"></div>
            <div id="profile__contents">
                <h2>%{$setting['display_name']}</h2>
                <div id="profile__sns-links">
                    <?php foreach ($accounts as $account) {
                        if (strstr($account['icon'], "http")) {
                            echo ('<a href="' . $account['url'] . '" class="profile__sns-links__icon"><img src="' . $account['icon'] . '"style="vertical-align: middle; max-height:28px;" alt="オーサーアイコン"></a>');
                        } else if ($account['icon'] == "pixiv") {
                            echo ('<a href="' . $account['url'] . '" class="profile__sns-links__icon"><img src="./resource/pixiv.png" width=28 height=28 style="vertical-align: middle" alt="オーサーアイコン"></a>');
                        } else {
                            echo ('<a href="' . $account['url'] . '" class="profile__sns-links__icon"><i class="' . $account['icon'] . '"></i></a>');
                        }
                    } ?>
                </div>
            </div>
        </div>
        <div id="instraction-area">
            <div class="home_menu_area">#{$home_menu}</div>
        </div>
        <div id="contents-area">
            <div id="content">
                #{$articles['comment']}<br>
            </div>
        </div>
        <footer id="footer-area">
            copyright %{$setting['display_name']} <a href="./console.php">#{$post_link}</a><br>
            powered by <a href="https://ppp.kannagi.net/" target="_blank">PictPostPersonal SBS</a>
        </footer>
    </div>

    </div>

</body>

</html>