<?php
if ($mode == "site") {
    //サイト全体NSFW標示の時のメッセージ
    $caption = "サイト";
    $cancel = "退出します";
} else {
    //記事事NSFW標示の時のメッセージ
    $caption = "記事";
    $cancel = "いいえ、戻ります";
}
?>
<!doctype html>
<html lang="ja">

<head>
    <meta charset="utf-8">
    <title><?= $setting['site_title']; ?> NSFW確認画面</title>

    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="theme-color" content="#fafafa">

    <!--twitter card -->
    <meta name="twitter:card" content="%{$document['card_type']}">
    <meta name="og:title" content="%{$document['card_title']}">
    <meta name="og:description" content="%{$document['card_comment']}">
    <meta name="twitter:title" content="%{$document['card_title']}">
    <meta name="twitter:description" content="%{$document['card_comment']}">
    <?php if ($document['card_thumbnail'] != "") { ?>
        <meta name="og:image" content="%{$document['card_thumbnail']}">
        <meta name="twitter:image" content="%{$document['card_thumbnail']}">
    <?php } ?>

    <link rel="stylesheet" href="./style/recss.css">
    <link rel="stylesheet" href="./style/base.css">
    <link rel="stylesheet" href="./module/fontawesome/css/all.min.css" rel="preload">
    <link rel="stylesheet" href="./env/user.css?%{$setting['css_update']}">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.7.1/jquery.min.js"></script>
    <script src="https://ajax.googleapis.com/ajax/libs/jqueryui/1.13.2/jquery-ui.min.js"></script>
    <script src="./script/dialog.js?ver=<?= $VERSION ?>"></script>
    <link rel="stylesheet" href="./style/dialog.css">
    <script src="./script/common.js?ver=<?= $VERSION ?>"></script>
    <script>
        $(async function() {
            $('#conform_button').on('click', function() {
                location.href = "./nsfw.php?nsfw=true<?= $location ?>";
            });

            $("#cancel_button").on("click", function() {
                location.href = "<?= $cancel_url ?>";
            });
        });
    </script>
    <style>
        div#base {
            display: flex;
            justify-content: center;
            align-items: center;
            margin-top: 1em;
        }

        h1 {
            margin-bottom: 1em;
        }

        .button {
            margin: 2em;
            width: 20em;
            height: 4em;

        }
    </style>
</head>

<body>
    <div id="base">
        <h1><?= $title ?></h1>
        <div id="contents_area">
            <p>
                この<?= $caption ?>には18歳未満の方に不適切な表現が含まれます<br>
            </p>
            <p>
                あなたは18歳以上ですか？
            </p>
        </div>
        <div id="control">
            <button id="conform_button" class="button button_force">18歳以上でNSFWコンテンツの閲覧に同意します</button><br>
            <button id="cancel_button" class="button button_normal"><?= $cancel ?></button>
        </div>
    </div>

</body>

</html>